#include <stdio.h>
#include <assert.h>

#define NMAX 101
#define MMAX 20

char A[NMAX][NMAX], used[NMAX];
int tero[NMAX], assoc_bit[NMAX], pred_bitmask[NMAX], p2[NMAX], cnt[1 << MMAX];
int comb[NMAX][NMAX];
long long a, b;
int N, M, K, R, i, j, conf, limit;

int main() {
	// Citeste datele de intrare.
	freopen("teroristi.in", "r", stdin);
	scanf("%d %d %d", &N, &K, &R);
	while (K--) {
		scanf("%d %d", &i, &j);
		A[i][j] = 1;
		used[i] = used[j] = 1;
	}

	// Determina teroristii care apar in cel putin 1 restrictie.
	M = 0;
	for (i = 1; i <= N; i++)
		if (used[i]) {
			tero[M] = i;
			assoc_bit[i] = M;
			M++;
		}

	// Calculeaza mastile de biti pentru predecesori.
	for (i = 0; i < M; i++) {
		if (i == 0)
			p2[i] = 1;
		else
			p2[i] = p2[i - 1] << 1;
	}

	for (i = 0; i < M; i++) {
		pred_bitmask[i] = 0;
		for (j = 0; j < M; j++)
			if (A[tero[j]][tero[i]])
				pred_bitmask[i] |= p2[j];
	}

	// Calculeaza dinamica pe configuratii (2^M * M).
	cnt[0] = 1 % R;
	limit = 1 << M;
	for (conf = 0; conf < limit; ++conf) {
		for (i = 0; i < M; i++)
			if (((conf & p2[i]) == 0) && ((conf & pred_bitmask[i]) == pred_bitmask[i])) {
				cnt[conf | p2[i]] = (cnt[conf | p2[i]] + cnt[conf]) % R;
			}
	}

	// Inmulteste cu (N-M)!.
	int result = cnt[limit - 1];
	for (i = 1; i <= N - M; i++)
		result = ((long long) result * (long long) i) % R;

	// Calculeaza combinarile.
	comb[1][0] = comb[1][1] = 1 % R;
	for (i = 2; i <= N; i++) {
		comb[i][0] = 1;
		for (j = 1; j <= M && j <= i; j++)
			comb[i][j] = (comb[i - 1][j - 1] + comb[i - 1][j]) % R;
	}

	// Inmulteste cu comb(N,M).
	a = result;
	b = comb[N][M];
	a = (a * b) % R;
	result = a;

	// Afisaza rezultatul.
	freopen("teroristi.out", "w", stdout);
	printf("%d\n", result);
	
	return 0;
}
