/*
Time complexity: O(!M)
Memory complexity: O(M)
Score: 40
Author: Andrei Antonescu
*/
using namespace std;

#include <set>
#include <map>
#include <list>
#include <deque>
#include <stack>
#include <queue>
#include <cmath>
#include <ctime>
#include <cctype>
#include <cstdio>
#include <vector>
#include <string>
#include <bitset>
#include <utility>
#include <iomanip>
#include <fstream>
#include <cstring>
#include <sstream>
#include <iostream>
#include <algorithm>
#include <functional>

#define oo (1<<30)
#define f first
#define s second
#define II inline
#define db double
#define ll long long
#define pb push_back
#define mp make_pair
#define Size(V) ((ll)(V.size()))
#define all(V) (V).begin() , (V).end()
#define CC(V) memset((V),0,sizeof((V)))
#define CP(A,B) memcpy((A),(B),sizeof((B)))
#define FOR(i,a,b) for(int (i)=(a);(i)<=(b);++(i))
#define REP(i, N) for (int (i)=0;(i)<(int)(N);++(i))
#define FORit(it, x) for (__typeof((x).begin()) it = (x).begin(); it != (x).end(); ++it)
#define printll(x) printf("%lld",(x))
#define printsp() printf(" ")
#define newline() printf("\n")
#define readll(x) scanf("%lld",&(x))
#define debugll(x) fprintf(stderr,"%lld\n",(x))

#define IN "teroristi.in"
#define OUT "teroristi.out"
#define N_MAX (1<<7)

typedef vector<int> VI;
typedef pair<int,int> pi;
typedef pair<short int,short int> ps;
typedef vector<string> VS;
template<class T> string toString(T n) {ostringstream ost;ost<<n;ost.flush();return ost.str();}

int N,K,M,R;
ll cnt;
int Use[N_MAX],pos[N_MAX];
vector<pi> Res,orders;

II void scan() {
	freopen(IN,"r",stdin);
	freopen(OUT,"w",stdout);

	scanf("%d%d%d",&N,&K,&R);
	
	int x,y;
	FOR(i,1,K) {
		scanf("%d%d",&x,&y);
		Use[x] = 1;
		Use[y] = 1;
		Res.pb( mp(x,y) );
	}
}

II void normalize() {
	FOR(i,1,N)
		Use[i] += Use[i - 1];
	M = Use[N];	

	FORit(it,Res) {
		orders.pb( mp(Use[it->f],Use[it->s]) );
	}
}

II void back(int no) {
	if(no == M) {
		
		bool ok = true;
		FORit(it,orders)
			if(pos[it->f] > pos[it->s])
				ok = false;

		if(ok)
			++cnt;

		return;
	}

	FOR(i,1,M) {
		if(pos[i] != -1)
			continue;

		pos[i] = no;
		back(no + 1);
		pos[i] = -1;
	}
}

II void solve() {
	memset(pos, -1, sizeof(pos) );

	back(0);

    FOR(i, M + 1, N)
		cnt = (1LL * cnt * i) % R; 	
    
    printf("%lld\n",cnt % R);
}

int main() {
	scan();
	normalize();
	solve();
	return 0;
}

