/*
Time complexity: O(2^M * M + N)
Memory complexity: O(2^M)
Score: 100
Author: Andrei Antonescu
*/
using namespace std;

#include <set>
#include <map>
#include <list>
#include <deque>
#include <stack>
#include <queue>
#include <cmath>
#include <ctime>
#include <cctype>
#include <cstdio>
#include <vector>
#include <string>
#include <bitset>
#include <utility>
#include <iomanip>
#include <fstream>
#include <cstring>
#include <sstream>
#include <iostream>
#include <algorithm>
#include <functional>

#define oo (1<<30)
#define f first
#define s second
#define II inline
#define db double
#define ll long long
#define pb push_back
#define mp make_pair
#define Size(V) ((ll)(V.size()))
#define all(V) (V).begin() , (V).end()
#define CC(V) memset((V),0,sizeof((V)))
#define CP(A,B) memcpy((A),(B),sizeof((B)))
#define FOR(i,a,b) for(int (i)=(a);(i)<=(b);++(i))
#define REP(i, N) for (int (i)=0;(i)<(int)(N);++(i))
#define FORit(it, x) for (__typeof((x).begin()) it = (x).begin(); it != (x).end(); ++it)
#define printll(x) printf("%lld",(x))
#define printsp() printf(" ")
#define newline() printf("\n")
#define readll(x) scanf("%lld",&(x))
#define debugll(x) fprintf(stderr,"%lld\n",(x))

#define IN "teroristi.in"
#define OUT "teroristi.out"
#define N_MAX (1<<7)
#define M_MAX 21
#define bit(x) (1 << ((x) - 1))

typedef vector<int> VI;
typedef pair<int,int> pi;
typedef pair<short int,short int> ps;
typedef vector<string> VS;
template<class T> string toString(T n) {ostringstream ost;ost<<n;ost.flush();return ost.str();}

int N,K,M,R;
int Use[N_MAX],Required[N_MAX];
ll Dp[(1 << M_MAX)]; //number of linear extensions containing the elements for the binary config
vector<VI> B(N_MAX);
vector<pi> Res;

II void scan() {
	freopen(IN,"r",stdin);
	freopen(OUT,"w",stdout);

	scanf("%d%d%d",&N,&K,&R);
	
	int x,y;
	FOR(i, 1, K) {
		scanf("%d%d", &x, &y);
		Use[x] = 1;
		Use[y] = 1;
		Res.pb( mp(x,y) );
	}
	
}

II void normalize() {
	FOR(i,1,N)
		Use[i] += Use[i - 1];
	M = Use[N];	

	FORit(it,Res) {
		B[ Use[it->s] ].pb( Use[it->f] );
	}
}

II void solve() {

	Dp[0] = 1; //we have one extension for the empty set
	
	FOR(node, 1, M) {
		FORit(it, B[node])
			Required[node] |= bit(*it);
	}

	//FOR(node, 1, N)
	//	printf("%d\n", Required[node]);

	FOR(cfg, 0, (1<<M) - 1) {
		//we have a precomputed configuration, in Dp[ i ]
		//now we`ll try to add a new node to compute new configurations
		//for each node we`ll check if we have all the necessary nodes
		
		//printf("%d %d\n", cfg, Dp[cfg]);

		FOR(node, 1, M) {
			if( cfg & bit(node) )
				continue;
			if( (cfg & Required[node]) != Required[node])
				continue;
		
			//printf("%d comes from %d\n",cfg | bit(node), cfg);

			Dp[ cfg | bit(node) ] += Dp[cfg];

			if(Dp[ cfg | bit(node) ] >= R)
				Dp[ cfg | bit(node) ] -= R;
		}	
	} 

	ll res = Dp[ (1<<M) - 1 ];

	FOR(i, M + 1, N)
		res = (1LL * res * i) % R; 

	printf("%lld\n",res);
}

int main() {
	scan();
	normalize();
	solve();
	return 0;
} 


